﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Maps;
using System.Reflection;
using System.Collections;
using System.Collections.ObjectModel;

namespace XamOrgChart
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamOrgChart_NodeControlAttachedEvent(object sender, Infragistics.Controls.Maps.OrgChartNodeEventArgs e)
        {
            if (e.Node.Node.Level == 1)
            {
                OrgChartNode ocn = e.Node.Node;
                BindingFlags bf = BindingFlags.Instance | BindingFlags.NonPublic;

                PropertyInfo propInf = typeof(OrgChartNode).GetProperty("ItemsSources", bf);
                ObservableCollection<IEnumerable> itemsSources = propInf.GetValue(ocn, new object[] { }) as ObservableCollection<IEnumerable>;

                PropertyInfo propInf2 = typeof(OrgChartNode).GetProperty("ChildItems", bf);
                List<OrgChartNode> ChildNodesToBe = propInf2.GetValue(ocn, new object[] { }) as List<OrgChartNode>;
                for (int i = ChildNodesToBe.Count - 1; i >= 0; i--)
                {
                    if ((itemsSources[0] as ObservableCollection<Person>).Contains(ChildNodesToBe[i].Data))
                    {
                        ChildNodesToBe.RemoveAt(i);
                    }
                }
            }
        }
    }
}
